// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from system_modes_msgs:msg/ModeEvent.idl
// generated code does not contain a copyright notice
#include "system_modes_msgs/msg/detail/mode_event__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `start_mode`
// Member `goal_mode`
#include "system_modes_msgs/msg/detail/mode__functions.h"

bool
system_modes_msgs__msg__ModeEvent__init(system_modes_msgs__msg__ModeEvent * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  // start_mode
  if (!system_modes_msgs__msg__Mode__init(&msg->start_mode)) {
    system_modes_msgs__msg__ModeEvent__fini(msg);
    return false;
  }
  // goal_mode
  if (!system_modes_msgs__msg__Mode__init(&msg->goal_mode)) {
    system_modes_msgs__msg__ModeEvent__fini(msg);
    return false;
  }
  return true;
}

void
system_modes_msgs__msg__ModeEvent__fini(system_modes_msgs__msg__ModeEvent * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  // start_mode
  system_modes_msgs__msg__Mode__fini(&msg->start_mode);
  // goal_mode
  system_modes_msgs__msg__Mode__fini(&msg->goal_mode);
}

bool
system_modes_msgs__msg__ModeEvent__are_equal(const system_modes_msgs__msg__ModeEvent * lhs, const system_modes_msgs__msg__ModeEvent * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (lhs->timestamp != rhs->timestamp) {
    return false;
  }
  // start_mode
  if (!system_modes_msgs__msg__Mode__are_equal(
      &(lhs->start_mode), &(rhs->start_mode)))
  {
    return false;
  }
  // goal_mode
  if (!system_modes_msgs__msg__Mode__are_equal(
      &(lhs->goal_mode), &(rhs->goal_mode)))
  {
    return false;
  }
  return true;
}

bool
system_modes_msgs__msg__ModeEvent__copy(
  const system_modes_msgs__msg__ModeEvent * input,
  system_modes_msgs__msg__ModeEvent * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  output->timestamp = input->timestamp;
  // start_mode
  if (!system_modes_msgs__msg__Mode__copy(
      &(input->start_mode), &(output->start_mode)))
  {
    return false;
  }
  // goal_mode
  if (!system_modes_msgs__msg__Mode__copy(
      &(input->goal_mode), &(output->goal_mode)))
  {
    return false;
  }
  return true;
}

system_modes_msgs__msg__ModeEvent *
system_modes_msgs__msg__ModeEvent__create()
{
  system_modes_msgs__msg__ModeEvent * msg = (system_modes_msgs__msg__ModeEvent *)malloc(sizeof(system_modes_msgs__msg__ModeEvent));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(system_modes_msgs__msg__ModeEvent));
  bool success = system_modes_msgs__msg__ModeEvent__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
system_modes_msgs__msg__ModeEvent__destroy(system_modes_msgs__msg__ModeEvent * msg)
{
  if (msg) {
    system_modes_msgs__msg__ModeEvent__fini(msg);
  }
  free(msg);
}


bool
system_modes_msgs__msg__ModeEvent__Sequence__init(system_modes_msgs__msg__ModeEvent__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  system_modes_msgs__msg__ModeEvent * data = NULL;
  if (size) {
    data = (system_modes_msgs__msg__ModeEvent *)calloc(size, sizeof(system_modes_msgs__msg__ModeEvent));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = system_modes_msgs__msg__ModeEvent__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        system_modes_msgs__msg__ModeEvent__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
system_modes_msgs__msg__ModeEvent__Sequence__fini(system_modes_msgs__msg__ModeEvent__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      system_modes_msgs__msg__ModeEvent__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

system_modes_msgs__msg__ModeEvent__Sequence *
system_modes_msgs__msg__ModeEvent__Sequence__create(size_t size)
{
  system_modes_msgs__msg__ModeEvent__Sequence * array = (system_modes_msgs__msg__ModeEvent__Sequence *)malloc(sizeof(system_modes_msgs__msg__ModeEvent__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = system_modes_msgs__msg__ModeEvent__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
system_modes_msgs__msg__ModeEvent__Sequence__destroy(system_modes_msgs__msg__ModeEvent__Sequence * array)
{
  if (array) {
    system_modes_msgs__msg__ModeEvent__Sequence__fini(array);
  }
  free(array);
}

bool
system_modes_msgs__msg__ModeEvent__Sequence__are_equal(const system_modes_msgs__msg__ModeEvent__Sequence * lhs, const system_modes_msgs__msg__ModeEvent__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!system_modes_msgs__msg__ModeEvent__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
system_modes_msgs__msg__ModeEvent__Sequence__copy(
  const system_modes_msgs__msg__ModeEvent__Sequence * input,
  system_modes_msgs__msg__ModeEvent__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(system_modes_msgs__msg__ModeEvent);
    system_modes_msgs__msg__ModeEvent * data =
      (system_modes_msgs__msg__ModeEvent *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!system_modes_msgs__msg__ModeEvent__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          system_modes_msgs__msg__ModeEvent__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!system_modes_msgs__msg__ModeEvent__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
