// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from system_modes_msgs:srv/GetAvailableModes.idl
// generated code does not contain a copyright notice

#ifndef SYSTEM_MODES_MSGS__SRV__DETAIL__GET_AVAILABLE_MODES__TRAITS_HPP_
#define SYSTEM_MODES_MSGS__SRV__DETAIL__GET_AVAILABLE_MODES__TRAITS_HPP_

#include "system_modes_msgs/srv/detail/get_available_modes__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const system_modes_msgs::srv::GetAvailableModes_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const system_modes_msgs::srv::GetAvailableModes_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<system_modes_msgs::srv::GetAvailableModes_Request>()
{
  return "system_modes_msgs::srv::GetAvailableModes_Request";
}

template<>
inline const char * name<system_modes_msgs::srv::GetAvailableModes_Request>()
{
  return "system_modes_msgs/srv/GetAvailableModes_Request";
}

template<>
struct has_fixed_size<system_modes_msgs::srv::GetAvailableModes_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<system_modes_msgs::srv::GetAvailableModes_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<system_modes_msgs::srv::GetAvailableModes_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const system_modes_msgs::srv::GetAvailableModes_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: available_modes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.available_modes.size() == 0) {
      out << "available_modes: []\n";
    } else {
      out << "available_modes:\n";
      for (auto item : msg.available_modes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const system_modes_msgs::srv::GetAvailableModes_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<system_modes_msgs::srv::GetAvailableModes_Response>()
{
  return "system_modes_msgs::srv::GetAvailableModes_Response";
}

template<>
inline const char * name<system_modes_msgs::srv::GetAvailableModes_Response>()
{
  return "system_modes_msgs/srv/GetAvailableModes_Response";
}

template<>
struct has_fixed_size<system_modes_msgs::srv::GetAvailableModes_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<system_modes_msgs::srv::GetAvailableModes_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<system_modes_msgs::srv::GetAvailableModes_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<system_modes_msgs::srv::GetAvailableModes>()
{
  return "system_modes_msgs::srv::GetAvailableModes";
}

template<>
inline const char * name<system_modes_msgs::srv::GetAvailableModes>()
{
  return "system_modes_msgs/srv/GetAvailableModes";
}

template<>
struct has_fixed_size<system_modes_msgs::srv::GetAvailableModes>
  : std::integral_constant<
    bool,
    has_fixed_size<system_modes_msgs::srv::GetAvailableModes_Request>::value &&
    has_fixed_size<system_modes_msgs::srv::GetAvailableModes_Response>::value
  >
{
};

template<>
struct has_bounded_size<system_modes_msgs::srv::GetAvailableModes>
  : std::integral_constant<
    bool,
    has_bounded_size<system_modes_msgs::srv::GetAvailableModes_Request>::value &&
    has_bounded_size<system_modes_msgs::srv::GetAvailableModes_Response>::value
  >
{
};

template<>
struct is_service<system_modes_msgs::srv::GetAvailableModes>
  : std::true_type
{
};

template<>
struct is_service_request<system_modes_msgs::srv::GetAvailableModes_Request>
  : std::true_type
{
};

template<>
struct is_service_response<system_modes_msgs::srv::GetAvailableModes_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // SYSTEM_MODES_MSGS__SRV__DETAIL__GET_AVAILABLE_MODES__TRAITS_HPP_
